#ifndef code__crc__crc32_hxx_
#define code__crc__crc32_hxx_

#include <cstdint>
#include <string>

namespace code::crc
{

  class crc32
  {
  public:
    void
    reset();

    void
    update(char byte);

    void
    update(char const* data, std::size_t length);

    void
    update(std::string const& str);

    void
    update(std::istream& in);

    void
    finalize();

    std::uint32_t
    checksum() const;

  private:
    std::uint32_t checksum_{0xFFFFFFFF};
  };

  std::string
  to_string(crc32 const& checksum);

  std::string
  to_hex(crc32 const& checksum);

} // namespace code::crc

#endif
